#include<simplecpp>
#include<stdlib.h>
#include<math.h>
#include<time.h>
using namespace std;

void Addition();
void Multiplication();
void Trace();
void Determinant();
void Inverse();
double det(int n,double mat[10][10]);
void game();
void eigen2();
void checkeigen();

int main()
{
    cout<<"\t\tWelcome to THE MATRIX\n\n";
    cout<<"\n\tMENU";
    cout<<"\n1. Basic Operations";
    cout<<"\n2. Advanced Operations";
    cout<<"\n3. Applications";
    cout<<"\n4. Play the MATRIX Game ";
    cout<<"\n5. Exit ";
    int choice;
   do
   {
    cout<<"\n\nMAIN MENU";
    cout<<"\n\nEnter Your choice: ";
    cin>>choice;
    if(choice==1)
    {      int choice1;
           cout<<"\n\tSUB MENU";
           cout<<"\n1.Addition of two matrices";
           cout<<"\n2.Multiplication of two matrices";
           cout<<"\n3.Trace of a Matrice";
           cout<<"\nEnter your choice : ";
           cin>>choice1;

           switch(choice1)
            {
                case 1:Addition();
                break;
                case 2:Multiplication();
                break;
                case 3:Trace();
                break;
                default:cout<<"Invalid Choice ....Exiting.../t/a/a";
                        exit(0);
            }
    }

    else if(choice==2)
    {
           int choice2;
           cout<<"\n\tSUB MENU";
           cout<<"\n1.Determinant value of a Matrice";
           cout<<"\n2.Inverse of given Matrix";
           cout<<"\nEnter your choice : ";
           cin>>choice2;
           switch(choice2)
            {
                case 1:Determinant();
                break;
                case 2:Inverse();
                break;
                default:cout<<"Invalid Choice ....Exiting.../t/a/a";
                        exit(0);
            }

    }

    else if(choice==3)
    {
           int choice3;
           cout<<"\n\tSUB MENU";
           cout<<"\n1.Find Eigen values of a 2x2 matrix";
           cout<<"\n2.Check whether a given value is an eigen value for a given Matrix";
           cout<<"\nEnter your choice : ";
           cin>>choice3;
           switch(choice3)
            {
                case 1:eigen2();
                break;
                case 2:checkeigen();
                break;
                default:cout<<"Invalid Choice ....Exiting...\t\a\a";
                        exit(0);
            }

    }

    else if(choice==4)
    {
        cout<<"\n\nThe MATRIX Game ... ";
        game();
    }

    else if(choice==5)
    {
        cout<<"\n\nExiting...";
        exit(0);
    }

    else
    {
        cout<<"\n\n\tINVALID CHOICE......\a\a\a";
    }
   }while(choice!=5);
}


void Addition()
{

     int m,n,i,j,first[10][10],second[10][10],sum[10][10];

   cout<< "Enter the number of rows and columns of matrix ";
   cin>>m>>n;
   cout<<"Enter the elements of first matrix\n";

   for(i=0;i<m;i++)
      for(j=0;j<n;j++)
         cin>>first[i][j];

    cout<<"Enter the elements of second matrix\n";

   for(i=0;i<m;i++)
      for(j=0;j<n;j++)
         cin>>second[i][j];

   for(i=0;i<m;i++)
      for(j=0;j<n;j++)
         sum[i][j]= first[i][j]+second[i][j];

   cout<<"Sum of entered matrices:-\n";

   for(i=0;i<m;i++)
   {
      for(j=0;j<n;j++)
         cout<<sum[i][j]<<"\t";

      cout<<endl;
   }

}


void Multiplication()
{
    int a[10][10], b[10][10],c[10][10];
    int x,y,i,j,m,n;


    cout<<"\nEnter the number of rows and columns for Matrix A :\n\n";
    cin>>x>>y;

    // x denotes number rows in matrix A
    // y denotes number columns in matrix A

    cout<<"\n\nEnter elements for Matrix A :\n\n";

    for(i=0;i<x;i++)
    {
        for(j=0;j<y;j++)
        {
            cin>>a[i][j];
        }
        cout<<"\n";
    }



    cout<<"\n\nMatrix A :\n\n";

    for(i=0;i<x;i++)
    {
        for(j=0;j<y;j++)
        {
            cout<<"\t"<<a[i][j];
        }
        cout<<"\n\n";
    }

    cout<<"\n-----------------------------------------------------------\n";

    cout<<"\nEnter the number of rows and columns for Matrix B:::\n\n";
    cin>>m>>n;

    // m denotes number rows in matrix B
    // n denotes number columns in matrix B


    cout<<"\n\nEnter elements for Matrix B :::\n\n";

    for(i=0;i<m;i++)
    {
        for(j=0;j<n;j++)
        {
            cin>>b[i][j];
        }
        cout<<"\n";
    }


    cout<<"\n\nMatrix B :\n\n";

    for(i=0;i<m;i++)
    {
        for(j=0;j<n;j++)
        {
            cout<<"\t"<<b[i][j];
        }
        cout<<"\n\n";
    }

    if(y==m)
    {

        for(i=0;i<x;i++)
        {
            for(j=0;j<n;j++)
            {
                c[i][j]=0;
                for(int k=0;k<m;k++)
                {
                    c[i][j]=c[i][j]+a[i][k]*b[k][j];
                }
            }
        }

        cout<<"\n-----------------------------------------------------------\n";

        cout<<"\n\nMultiplication of Matrix A and Matrix B :\n\n";

        for(i=0;i<x;i++)
        {
            for(j=0;j<n;j++)
            {
                cout<<"\t"<<c[i][j];
            }
            cout<<"\n\n";
        }
    }
    else
    {
        cout<<"\n\nMultiplication is not possible";
    }

}



void Trace()
{
    int n;
    int a[10][10];
    cout<<"\nEnter no of rows and columns (Both are same) : ";
    cin>>n;
    cout<<"Enter elements of Matrix : ";
    for(int i=0;i<n;i++)
      for(int j=0;j<n;j++)
         cin>>a[i][j];

    int trace=0;
    for(int i=0;i<n;i++)
      for(int j=0;j<n;j++)
        {
            if(i==j) trace=trace+a[i][j];
         }
    cout<<"Trace of given Matrice is : "<<trace;

}

void Determinant()
{
    int n;
    cout<<"Enter the order of matrix :";
    cin>>n;
    double mat[10][10];
    int i, j;
    cout<<"Enter the elements"<<endl;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            cin>>mat[i][j];
        }
    }
    cout<<"\nDeterminant value is : "<<det(n,mat);
}


double det(int n,double mat[10][10])
{
    double d=0;
    int c,subi,i,j,subj;
    double submat[10][10];
    if (n == 2)
    {
        return((mat[0][0]*mat[1][1])-(mat[1][0]*mat[0][1]));
    }
    else
    {
        for(c=0;c<n;c++)
        {
            subi=0;
            for(i=1;i<n;i++)
            {
                subj=0;
                for(j=0;j<n;j++)
                {
                    if(j==c)
                    {
                        continue;
                    }
                    submat[subi][subj]=mat[i][j];
                    subj++;
                }
                subi++;
            }
        d=d+(pow(-1,c)*mat[0][c]*det(n-1,submat));
        }
    }
    return d;
}


void game()
{

    cout<<"\n\nThe MATRIX Game";
    cout<<"The game is called Hit the matrix.\n\n";
    cout<<"It displays a 3x3 matrix with 9 squares of black colour. \n\n";
    cout<<"One square turns red randomly and you have to click on it in under one second .\n\n";
    cout<<"The Game gets over if you take more than one second\n";
    cout<<"to react or click at the wrong place.";
    cout<<"\n\nPress 'P' and enter to start play...";
    char c;
    cin>>c;

    int score=-1;
    int cp;
    initCanvas("Game",500,500);
    Rectangle r(250,250,480,480);
    Rectangle r1(120,120,40,40);
    Rectangle r2(240,120,40,40);
    Rectangle r3(360,120,40,40);
    Rectangle r4(120,240,40,40);
    Rectangle r5(240,240,40,40);
    Rectangle r6(360,240,40,40);
    Rectangle r7(120,360,40,40);
    Rectangle r8(240,360,40,40);
    Rectangle r9(360,360,40,40);

    r1.setColor(COLOR(0,0,0)); r1.setFill();
    r2.setColor(COLOR(0,0,0)); r2.setFill();
    r3.setColor(COLOR(0,0,0)); r3.setFill();
    r4.setColor(COLOR(0,0,0)); r4.setFill();
    r5.setColor(COLOR(0,0,0)); r5.setFill();
    r6.setColor(COLOR(0,0,0)); r6.setFill();
    r7.setColor(COLOR(0,0,0)); r7.setFill();
    r8.setColor(COLOR(0,0,0)); r8.setFill();
    r9.setColor(COLOR(0,0,0)); r9.setFill();


    int i=1,j;
    for(j=0;j==0;)
    {   score++;
        i=rand()%10+1; if(i==10)i--;
        if(i==1) r1.setColor(COLOR(255,0,0));
        if(i==2) r2.setColor(COLOR(255,0,0));
        if(i==3) r3.setColor(COLOR(255,0,0));
        if(i==4) r4.setColor(COLOR(255,0,0));
        if(i==5) r5.setColor(COLOR(255,0,0));
        if(i==6) r6.setColor(COLOR(255,0,0));
        if(i==7) r7.setColor(COLOR(255,0,0));
        if(i==8) r8.setColor(COLOR(255,0,0));
        if(i==9) r9.setColor(COLOR(255,0,0));

        time_t t1=time(0);
        cp=getClick();
        time_t t2=time(0);
        double seconds=difftime(t2,t1);
        if(seconds>1) j=1;
        int cx=cp/65536;
        int cy=cp%65536;

        if(i==1)
        {
            if(cx>140||cx<100||cy>140||cy<100)
                j=2;
        }
        if(i==2)
        {
            if(cx>260||cx<220||cy>140||cy<100)
                j=2;
        }
        if(i==3)
        {
            if(cx>380||cx<340||cy>140||cy<100)
                j=2;
        }
        if(i==4)
        {
            if(cx>140||cx<100||cy>260||cy<220)
                j=2;
        }
        if(i==5)
        {
            if(cx>260||cx<220||cy>260||cy<220)
                j=2;
        }
        if(i==6)
        {
            if(cx>380||cx<340||cy>260||cy<220)
                j=2;
        }
        if(i==7)
        {
            if(cx>140||cx<100||cy>380||cy<340)
                j=2;
        }
        if(i==8)
        {
            if(cx>260||cx<220||cy>380||cy<340)
                j=2;
        }
        if(i==9)
        {
            if(cx>380||cx<340||cy>380||cy<340)
                j=2;
        }

        r1.setColor(COLOR(0,0,0));
        r2.setColor(COLOR(0,0,0));
        r3.setColor(COLOR(0,0,0));
        r4.setColor(COLOR(0,0,0));
        r5.setColor(COLOR(0,0,0));
        r6.setColor(COLOR(0,0,0));
        r7.setColor(COLOR(0,0,0));
        r8.setColor(COLOR(0,0,0));
        r9.setColor(COLOR(0,0,0));
    }


    Rectangle rr(250,250,500,500);
    rr.setColor(COLOR(255,255,255)); rr.setFill();
    Text q1(250,220,"GAME OVER");
    if(j==1)  Text q4(250,200,"You took too much TIME...!!!");
    if(j==2)  Text q5(250,200,"You missed the target...!!!");
    Text q2(250,280,"Score : ");
    Text q3(280,280,score);
    wait(5);
}


void Inverse()
{

float matrix[10][10],ratio,a;
int i,j,k,n;
cout<<"\nEnter order of matrix: ";
cin>>n;

cout<<"\nEnter the matrix: \n";
for(i=0;i<n;i++)
    {
      for(j=0;j<n;j++)
           {
            cin>>matrix[i][j];
           }
    }

for(i=0;i<n;i++)
    {
      for(j=n;j<2*n;j++)
           {
            if(i==(j-n))
            matrix[i][j]=1.0;
            else
            matrix[i][j]=0.0;
           }
    }

for(i=0;i<n;i++)
    {
      for(j=0;j<n;j++)
           {
            if(i!=j)
               {
                 ratio=matrix[j][i]/matrix[i][i];
                 for(k=0;k<2*n;k++)
                     {
                      matrix[j][k]-=ratio*matrix[i][k];
                     }
               }
            }
    }

for(i=0;i<n;i++)
    {
      a=matrix[i][i];
      for(j=0;j<2*n;j++)
            {
             matrix[i][j]/=a;
            }
    }

cout<<"\nThe inverse matrix is: \n";
for(i=0;i<n;i++)
    {
      for(j=n;j<2*n;j++)
            {
             cout<<matrix[i][j]<<"\t";
            }
      cout<<"\n";
    }
}


void eigen2()
{   float a,b,c,d,e1,e2,root;
    cout<<"\n\nEnter a 2x2 Matrix Values... ";
    cin>>a>>b>>c>>d;
    cout<<"\nGiven Matrix is :\n";
    cout<<a<<"\t"<<b<<"\n"<<c<<"\t"<<d;
    root=((a+d)*(a+d)) -(4*(a*d-b*c));
    if(root>=0)
    {
        root=pow(root,0.5);
        e1=(a+d+root)/2;
        e2=((a+d)-root)/2;
        cout<<"\nThe Eigen values of given Matrix are : ";
        cout<<e1<<"    and    "<<e2;
    }
    else
    {
    cout<<"\nNo Eigen Values exist for given Matrix ... ";
    }
}

void checkeigen()
{
    int n;
    cout<<"\nEnter order of matrix: ";
    cin>>n;
    double mat[10][10];
    cout<<"\nEnter the matrix: \n";
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
           {
            cin>>mat[i][j];
           }
    }
    cout<<"\nEntered Matrix is...\n";
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
           {
            cout<<mat[i][j];
           }
    }
    double v;
    cout<<"\nEnter a value which you suspect to be an eigen value for the given matrix : ";
    cin>>v;
    for(int i=0;i<n;i++)
        {
            for(int j=0;j<n;j++)
            {
                if(i==j)  mat[i][j]=mat[i][j]-v;
            }
        }
    double detv;
    detv=det(n,mat);
    if(detv==0)
         cout<<"\nGiven Value IS an Eigen Value of the Matrix...";
    else
         cout<<"\nGiven Value is NOT an Eigen Value of given Matrix...";

}

